<?php
/*
 * Created on 3.5.2011
 *
 * Author: Filip Bartmann
 * Project: com_ch_pay_j15
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgCHPPayPal extends JPlugin {
	private $_params=null;
	private $_data=null;
	function __construct() {
		$plugin=JPluginHelper::getPlugin('chp','paypal');
		$this->_params=new JParameter($plugin->params);
		$this->_data=new stdClass();

		JFactory::getLanguage()->load('plg_chp_paypal',JPATH_ADMINISTRATOR);
	}

	function getImage() {
		return JText::_('PAYPAL_IMAGE');
	}

	function _getNativeCurrencies() {
		return array('CZK','EUR','GBP');
	}

	function getInfo() {
		$db=JFactory::getDBO();
		$details_page=false;
		$currencies=array();
		foreach($this->_getNativeCurrencies() as $currency) {
			$currencies[]=$db->quote($currency);
		}

		$query="SELECT DISTINCT from_currency \n";
		$query.="FROM #__chp_courses \n";
		$query.="WHERE to_currency IN(".implode(",",$currencies).") AND from_currency NOT IN(".implode(",",$currencies).") \n";
		$db->setQuery($query);
		$currencies=$db->loadResultArray();
		$currencies=array_merge($this->_getNativeCurrencies(),$currencies);
		return array('details_page'=>$details_page,'currencies'=>$currencies,'check_invoicenum'=>0);
	}

	private function _getRate($data) {
		$db=JFactory::getDBO();
		$native_currencies=$this->_getNativeCurrencies();
		$rate=1;
		if(!in_array($data->currency,$native_currencies)) {
			$query="SELECT conversion_rate \n";
			$query.="FROM #__chp_courses \n";
			$query.="WHERE from_currency=".$db->quote($data->currency)." AND to_currency=".$db->quote($this->_params->get('main_currency','CZK'));
			$db->setQuery($query);
			$rate=$db->loadResult();
		}
		return $rate;
	}

	function createPay($data,$is_ssl=true) {
		$rate=$this->_getRate($data);
		$currency=$data->currency;
		$native_currencies=$this->_getNativeCurrencies();
		if(!in_array($currency,$native_currencies)) {
			$currency=$this->_params->get('main_currency','CZK');
		}
		
		JFactory::getApplication()->setUserState('com_chpay.pay_id',$data->id);

		$url_params=array();
		$url_params["cmd"]="_xclick";
		//$url_params["notify_url"]=($is_ssl?"https://":"http://").JFactory::getUri()->getHost()."/".JRoute::_('index.php?option=com_chpay&controller=payments&task=pay_finish&id='.$data->plugin_id.'&notify=1',false);
		$url_params["notify_url"]=($is_ssl?"https://":"http://").JFactory::getUri()->getHost()."/plugins/chp/paypal_notify.php";
		$url_params["business"]=$this->_params->get('api_username');
		$url_params["amount"]=round($data->amount*$rate,2);
		$url_params["currency_code"]=$currency;
		$url_params["item_name"]=$data->description;
		$url_params["invoice"]=$data->var_sym;
		$url_params["custom"]=$data->id;
		$url_params["paymentaction"]=$this->_params->get('pay_type','sale');
		$url_params["return"]=($is_ssl?"https://":"http://").JFactory::getUri()->getHost()."/".JRoute::_('index.php?option=com_chpay&controller=payments&task=pay_finish&id='.$data->plugin_id,false);
		$url_params["cancel_return"]=($is_ssl?"https://":"http://").JFactory::getUri()->getHost()."/".JRoute::_('index.php?option=com_chpay&controller=payments&task=pay_cancel&id='.$data->plugin_id,false);
		if(strlen($this->_params->get('image_url'))) {
			$url_params["image_url"]=$this->_params->get('image_url');
		}
		
		$url=$this->_getPayUrl()."webscr?".http_build_query($url_params);
		header("Location: ".$url);
		JFactory::getApplication()->close();
		
		return true;
	}
	
	function payCancel(&$table) {
		$table->load(JFactory::getApplication()->getUserState('com_chpay.pay_id'));
		return true;
	}

	function finishPay(&$tdata) {
		if(JRequest::getVar('notify',0)==0) {
			$tdata->load(JFactory::getApplication()->getUserState('com_chpay.pay_id'));
			return true;
		} else {
			$post=JRequest::get('post');	
			$url_params=array();
			$url_params["cmd"]="_notify-validate";
			foreach($post as $key=>$val) {
				if($key=="view") {
					continue;
				}
				$url_params[$key]=$val;
			}
			
			/*$tmp_file=JFactory::getApplication()->getCfg('tmp_path')."/payment1.txt";
			file_put_contents($tmp_file,print_r($url_params,true));*/
			$c=curl_init($this->_getPayUrl()."/cgi-bin/webscr/");
			curl_setopt($c,CURLOPT_POST,1);
			curl_setopt($c,CURLOPT_POSTFIELDS,$url_params);
			curl_setopt($c,CURLOPT_RETURNTRANSFER,1);
			$data=curl_exec($c);
			curl_close($c);
			/*$tmp_file=JFactory::getApplication()->getCfg('tmp_path')."/payment2.txt";
			file_put_contents($tmp_file,print_r($data,true));*/
			if($data=="VERIFIED" && $post["payment_status"]=="Completed") {
				$tdata->load($post["custom"]);
				/*$tmp_file=JFactory::getApplication()->getCfg('tmp_path')."/payment3.txt";
				file_put_contents($tmp_file,round($tdata->amount,2)."==".round($post["mc_gross"],2));*/
				if(round($tdata->amount,2)==round($post["mc_gross"],2) && $tdata->currency==$post["mc_currency"]) {
					$tdata->state=2;
				}
			}
		}
		return true;
	}

	function makePayment($data) {
		$this->setError(JText::_('This feature is not supported'));
		return false;
	}

	private function _getPayUrl() {
		if($this->_params->get('test_mode')==1) {
			return "https://www.sandbox.paypal.com/";
		} else {
			return "https://www.paypal.com/";
		}
	}
}
?>