<?php
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class ChpayModelPayment extends JModel {
	private $_cid=null;
	private $_id=null;
	private $_user=null;
	private $_table=null;

	function __construct() {
		parent::__construct();

		$this->_cid=JRequest::getVar('cid',array("0"),'','array');
		$this->_id=$this->_cid[0];
		$this->_user=JFactory::getUser();
		$this->_table=$this->getTable('payment');
	}

	function getData() {
		$this->_table->load($this->_id);
		if($this->_id==0) {
			$app=JFactory::getApplication();
			$option=JRequest::getCmd('option');

			$this->_table->plugin_id=$app->getUserState($option.'plugin_id');
			$this->_table->currency=$app->getUserState($option.'currency');
		}
		if(JRequest::getCmd('layout','default')=='default') {
			$query="SELECT name \n";
			$query.="FROM #__plugins \n";
			$query.="WHERE id=".$this->_table->plugin_id;
			$this->_db->setQUery($query);
			$this->_table->plugin=$this->_db->loadResult();
		}
		return $this->_table;
	}

	function getLists() {
		$query="SELECT id, name AS title \n";
		$query.="FROM #__plugins \n";
		$query.="WHERE folder=".$this->_db->quote('chp')." AND published=1 \n";
		$query.="ORDER BY title \n";
		$this->_db->setQUery($query);
		$plugins_ol=array_merge(array(JHTML::_('select.option',-1,JText::_('Select plugin'),'id','title')),$this->_db->loadObjectList());

		$currencies=array("CZK","EUR","GBP");
		$currencies_arr=array();
		$currencies_arr[]=JHTML::_('select.option',-1,JText::_('Select currency'),'id','title');
		for($i=0;$i<count($currencies);$i++) {
			$currencies_arr[]=JHTML::_('select.option',$currencies[$i],$currencies[$i],'id','title');
		}
		
		$state_a=array();
		$state_a[]=JHTML::_('select.option',0,JText::_('Unapyed'),'id','title');
		//$state_a[]=JHTML::_('select.option',1,JText::_('Authorized'),'id','title');
		$state_a[]=JHTML::_('select.option',2,JText::_('Payed'),'id','title');

		$lists["plugin_id"]=JHTML::_('select.genericlist',$plugins_ol,'plugin_id','class="inputbox"','id','title',$this->_table->plugin_id);
		$lists["currency"]=JHTML::_('select.genericlist',$currencies_arr,'currency','class="inputbox"','id','title',$this->_table->currency);
		$lists["state"]=JHTML::_('select.radiolist',$state_a,'state','class="inputbox"','id','title',$this->_table->state);

		return $lists;
	}

	function store($datas) {
		$this->_table->bind($datas);
		$this->_table->id=$this->_id;
		if($this->_id==0) {
			$this->_table->ip_addr="0.0.0.0";
		}
		$this->_table->date_payed=JFactory::getDate($this->_table->date_payed)->toMySQL();
		if(!$this->_table->store()) {
			$this->setError($this->_db->stderr(true));
			return false;
		}
		return true;
	}

	function delete() {
		$query="DELETE FROM ".$this->_table->getTableName()." \n";
		$query.="WHERE id IN (".implode(",",$this->_cid).") \n";
		$this->_db->setQuery($query);
		if(!$this->_db->query()) {
			$this->setError($this->_db->stderr(true));
			return false;
		}
		return true;
	}

	function checkout() {
		if(!$this->_table->checkout($this->_user->get('id'),$this->_id)) {
			$this->setError($this->_db->stderr(true));
			return false;
		}
		return true;
	}

	function checkin() {
		if(!$this->_table->checkin($this->_id)) {
			$this->setError($this->_db->stderr(true));
			return false;
		}
		return true;
	}
	
	function makePayment($id) {
		$query="SELECT p.id, p.state, p.amount, p.currency, p.var_sym, p.params, pl.element AS plugin \n";
		$query.="FROM #__chp_payments AS p \n";
		$query.="LEFT JOIN #__plugins AS pl ON p.plugin_id=pl.id \n";
		$query.="WHERE p.id=".$id;
		$this->_db->setQuery($query);
		$payment_o=$this->_db->loadObject();
		
		$this->_table->load($payment_o->id);
		
		$params=new JParameter($payment_o->params,JPATH_SITE.DS.'plugins'.DS.'chp'.DS.$payment_o->plugin.'.xml');
		$payment_o->params=$params;
		require_once JPATH_SITE.DS.'plugins'.DS.'chp'.DS.$payment_o->plugin.'.php';
		$plg_name='plgCHP'.$payment_o->plugin;
		$plugin=new $plg_name();
		if(!$plugin->makePayment($this->table)) {
			$this->setError($plugin->getError());
			return false;
		}
		
		if(!$this->_table->store()) {
			$this->setError($this->_db->stderr(true));
			return false;
		}
		return true;
	}
}
?>