<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class ChpayModelPayments  extends JModel {
	private $_limitstart=null;
	private $_limit=null;
	private $_orderBy=null;
	private $_orderDir=null;
	private $_plugin_id=null;
	private $_username=null;
	private $_var_sym=null;
	private $_currency=null;
	function __construct() {
		parent::__construct();
		$app=JFactory::getApplication();
		$option=JRequest::getCmd('option');

		$this->_limitstart=$app->getUserStateFromRequest($option.'limitstart','limitstart',0,'int');
		$this->_limit=$app->getUserStateFromRequest($option.'limit','limit',$app->getCfg('list_limit'),'int');
		$this->_orderBy=$app->getUserStateFromRequest($option.'filter_order','filter_order','pa.date_payed','string');
		$this->_orderDir=$app->getUserStateFromRequest($option.'filter_order_Dir','filter_order_Dir','DESC','string');
		$this->_plugin_id=$app->getUserStateFromRequest($option.'plugin_id','plugin_id',-1,'int');
		$this->_username=$app->getUserStateFromRequest($option.'name','name','','string');
		$this->_var_sym=$app->getUserStateFromRequest($option.'var_sym','var_sym','','string');
		$this->_currency=$app->getUserStateFromRequest($option.'currency','currency',-1,'string');
	}

	private function _setWhere() {
		$where=array();
		if($this->_plugin_id>0) {
			$where[]="pa.plugin_id=".$this->_plugin_id;
		}
		if(strlen($this->_username)) {
			//$where[]="LOWER(pa.name) LIKE '%".strtolower($this->_username)."%'";
		}
		if(strlen($this->_var_sym)) {
			$where[]="pa.var_sym=".$this->_db->quote($this->_var_sym);
		}
		if($this->_currency!=-1 && $this->_currency!='') {
			$where[]="pa.currency=".$this->_db->quote($this->_currency);
		}
		return count($where)?("WHERE ".implode(" AND ",$where)." \n"):"";
	}

	private function _setQuery() {
		$query="SELECT pa.description AS title, pa.*, pl.name AS plugin \n";
		$query.="FROM ".$this->getTable('payment')->getTableName()." AS pa \n";
		$query.="LEFT JOIN #__plugins AS pl ON pa.plugin_id=pl.id AND pl.folder=".$this->_db->quote('chp')." \n";
		$query.=$this->_setWhere();
		$query.="ORDER BY ".$this->_orderBy." ".$this->_orderDir." \n";
		return $query;
	}

	function getData() {
		return $this->_getList($this->_setQuery(),$this->_limitstart,$this->_limit);
	}

	function getPagination() {
		jimport('joomla.html.pagination');
		return new JPagination($this->_getListCount($this->_setQuery()),$this->_limitstart,$this->_limit);
	}

	function getLists() {
		$query="SELECT id, name AS title \n";
		$query.="FROM #__plugins \n";
		$query.="WHERE folder=".$this->_db->quote('chp')." AND published=1 \n";
		$query.="ORDER BY title \n";
		$this->_db->setQUery($query);
		$plugins_ol=array_merge(array(JHTML::_('select.option',-1,JText::_('Select plugin'),'id','title')),$this->_db->loadObjectList());

		$query="SELECT DISTINCT name AS id, name AS title \n";
		$query.="FROM #__chp_payments \n";
		$query.="ORDER BY name \n";
		$this->_db->setQuery($query);
		$names_ol=array_merge(array(JHTML::_('select.option',-1,JText::_('Select name'),'id','title')),$this->_db->loadObjectList());

		$currencies=array("CZK","EUR","GBP");
		$currencies_arr=array();
		$currencies_arr[]=JHTML::_('select.option',-1,JText::_('Select currency'),'id','title');
		for($i=0;$i<count($currencies);$i++) {
			$currencies_arr[]=JHTML::_('select.option',$currencies[$i],$currencies[$i],'id','title');
		}

		$lists["limitstart"]=$this->_limitstart;
		$lists["limit"]=$this->_limit;
		$lists["orderBy"]=$this->_orderBy;
		$lists["orderDir"]=$this->_orderDir;
		$lists["plugin_id"]=JHTML::_('select.genericlist',$plugins_ol,'plugin_id','class="inputbox" onchange="document.adminForm.submit();"','id','title',$this->_plugin_id);
		$lists["name"]=JHTML::_('select.genericlist',$names_ol,'name','class="inputbox" onchange="document.adminForm.submit();"','id','title',$this->_username);
		$lists["var_sym"]=$this->_var_sym;
		$lists["currency"]=JHTML::_('select.genericlist',$currencies_arr,'currency','class="inputbox" onchange="document.adminForm.submit();"','id','title',$this->_currency);

		return $lists;
	}
}
?>