<?php
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.folder');

class Captcha {
	private $_fontDir=null;
	private $_fonts=null;
	private $_length=null;
	protected $_string=null;
	protected $_image=null;
	private $_width=null;
	private $_height=null;

	function __construct() {
		$this->_fontDir=dirname(__FILE__).DS.'fonts'.DS;
	}

	function getInstance() {
		return new Captcha();
	}

	private function _getFonts() {
		$this->_fonts=array();
		if(is_dir($this->_fontDir)) {
			$this->_fonts=JFolder::files($this->_fontDir,".ttf");
		}
	}

	private function _getString() {
		$alphabet=array();
		$this->_string=array();
		for($c=65;$c<=90;$c++) {
			$alphabet[]=chr($c);
		}
		for($i=1;$i<=9;$i++) {
			$alphabet[]=$i;
		}
		for($i=0;$i<$this->_length;$i++) {
			$this->_string[]=$alphabet[array_rand($alphabet)];
		}
	}

	private function _drawString() {
		for($i=0;$i<count($this->_string);$i++) {
			$font=$this->_fontDir.DS.$this->_fonts[array_rand($this->_fonts)];
			$tcolor=imagecolorallocate($this->_image,rand(0,100),rand(0,100),rand(0,100));
			$size=rand(16,25);
			$angle=rand(-30,30);
			$char=imageftbbox($size,$angle,$font,$this->_string[$i],array());
			$spacing=$this->_width/$this->_length;
			//imagefttext($this->_image,$size,$angle,($spacing/4+$i*$spacing),($this->_height/2+($char[2]-$char[5])/4),$tcolor,$font,$this->_string[$i],array());
			imagefttext($this->_image,$size,$angle,($spacing/4+$i*$spacing),$this->_height-10,$tcolor,$font,$this->_string[$i],array());
		}
	}

	private function _drawLines() {
		for($i=0;$i<70;$i++) {
			$color=imagecolorallocate($this->_image,rand(100,250),rand(100,250),rand(100,250));
			imageline($this->_image,rand(0,$this->_width),rand(0,$this->_height),rand(0,$this->_width),rand(0,$this->_height),$color);
		}
	}

	function getImage($length) {
		$this->_length=$length;
		$this->_width=200;
		$this->_height=60;
		$this->_image=imagecreatetruecolor($this->_width,$this->_height);
		$white=imagecolorallocate($this->_image,255,255,255);
		imagefill($this->_image,0,0,$white);
		$this->_drawLines();
		$this->_getFonts();
		$this->_getString();
		$this->_drawString();
		JFactory::getApplication()->setUserState('captcha',implode("",$this->_string));
		header("Content-type:image/png");
		imagepng($this->_image);
		imagedestroy($this->_image);
	}

	function validate($string) {
		$captcha=JFactory::getApplication()->getUserState('captcha');
		if(strlen($captcha) && strtolower($string)==strtolower($captcha)) {
			return true;
		}
		return false;
	}
}
?>