<?php
/*
 * Created on 2.5.2011
 *
 * Author: Filip Bartmann
 * Project: com_ch_pay_j15
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
require_once JPATH_COMPONENT.DS.'libs'.DS.'captcha'.DS.'captcha.php';

class CHPayModelPay extends JModel {
	private $_config=null;
	private $_captcha=null;
	private $_url=null;
	function __construct() {
		parent::__construct();
		$this->_config=$this->getTable('configuration');
		$this->_config->load();
		$this->_captcha=Captcha::getInstance();
	}

	function getConfig() {
		return $this->_config;
	}

	function getCaptcha() {
		return $this->_captcha->getImage($this->_config->captcha_len);
	}

	function getLists() {
		$query="SELECT id, element, name, params \n";
		$query.="FROM #__plugins \n";
		$query.="WHERE folder=".$this->_db->quote('chp')." AND published=1 \n";
		$query.="ORDER BY ordering \n";
		$this->_db->setQUery($query);
		$plugins=$this->_db->loadObjectList();

		$plugins_arr=array();
		for($i=0;$i<count($plugins);$i++) {
			$plg_name="plgCHP".$plugins[$i]->element;

			require_once JPATH_SITE.DS.'plugins'.DS.'chp'.DS.$plugins[$i]->element.'.php';

			$plugin=new $plg_name();
			$image=$plugin->getImage();
			if(is_array($image)) {
				$plugins_arr=array_merge($plugins_arr,$image);	
			} else {
				$plugin_o=new stdClass();
				$plugin_o->id=$plugins[$i]->id;
				$plugin_o->value=$plugins[$i]->id;
				$plugin_o->title=$image;
				$plugins_arr[]=$plugin_o;
			}
		}

		$currencies_arr=array();
		$currencies_arr[]=JHTML::_('select.option',$this->_config->default_currency,$this->_config->default_currency,'id','title');

		$lists["plugin_id"]=$plugins_arr;
		$lists["currency"]=JHTML::_('select.genericlist',$currencies_arr,'currency','class="inputbox"','id','title');		


		return $lists;
	}
	
	function getFields() {
		$plugin=$this->_getPlugin(JRequest::getInt('id'));
		$html="";
		if(method_exists($plugin,"getFields")) {
			$fields=$plugin->getFields();
			foreach($fields as $field) {
				$html.="<tr><td>".$field["label"]."</td><td>".$field["field"]."</td></tr>";				
			}
		}
		return $html;
	}

	function checkCaptcha() {
		return ($this->_captcha->validate(JRequest::getString('captcha')))?1:0;
	}

	function getIsBanned() {
		$time=localtime(time(),true);
		$date=JFactory::getDate();
		$date->setOffset(JFactory::getApplication()->getCfg('offset'));
		$date=$date->toUnix(true);
		if($time["tm_isdst"]==1) {
			$date+=3600;
		}
		$before_date=$date-($this->_config->bann_time*60*60);

		$query="SELECT COUNT(*) \n";
		$query.="FROM #__chp_payments \n";
		$query.="WHERE ip_addr=".$this->_db->quote($this->_getIPAddr())." \n";
		$query.="AND date_payed BETWEEN ".$this->_db->quote(JFactory::getDate($before_date)->toMySQL())." \n";
		$query.="AND ".$this->_db->quote(JFactory::getDate($date)->toMySQL())." \n";

		$this->_db->setQuery($query);
		$cnt=$this->_db->loadResult();

		if($cnt>=$this->_config->max_try) {
			return 0;
		}
		return 1;
	}

	function checkVarSym() {
		$query="SELECT COUNT(*) \n";
		$query.="FROM #__chp_payments \n";
		$query.="WHERE var_sym=".$this->_db->quote(JRequest::getString('var_sym'))." AND plugin_id=".JRequest::getInt('plugin_id')." AND state!=0";
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}

	private function _getIPAddr() {
		if(!empty($_SERVER['HTTP_CLIENT_IP'])) {
			return $_SERVER['HTTP_CLIENT_IP'];
		} else if(!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
			return $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			return $_SERVER['REMOTE_ADDR'];
		}
	}

	function getPayDetails() {
		$data=array();
		parse_str(base64_decode(JRequest::getString('data')),$data);
		$data=(object)$data;

		$plugin=$this->_getPlugin(JRequest::getInt('plugin_id'));
		return $plugin->payDetails($data);
	}

	function getInfo() {
		$plugin=$this->_getPlugin(JRequest::getInt('id'));
		return json_encode($plugin->getInfo());
	}

	function payProcess() {
		$err=true;
		$table=$this->getTable('payment');
		$table->bind(JRequest::get('post'));
		$table->ip_addr=$this->_getIPAddr();

		$date=JFactory::getDate();
		$date->setOffset(JFactory::getApplication()->getCfg('offset'));
		$date_payed=$date->toUnix(true);
		$time=localtime(time(),true);
		if($time["tm_isdst"]==1) {
			$date_payed+=3600;
		}

		$table->date_payed=JFactory::getDate($date_payed)->toMySQL();
		$table->state=0;
		$table->plugin_id=JRequest::getInt('plugin_id');
		$table->amount=JRequest::getString('amount');
		$table->currency=JRequest::getString('currency');
		if(!$table->store()) {
			$this->setError($this->_db->stderr(true));
			return false;
		}
		
		JFactory::getApplication()->setUserState('com_chpay.lang_id',JFactory::getLanguage()->getTag());
		
		$plugin=$this->_getPlugin($table->plugin_id);
		if(!$plugin->createPay($table,$this->_config->use_ssl)) {
			$table->message=$plugin->getError();
			$this->setError($table->message);
			$table->store();
			return false;
		}
		
		return true;
	}
	
	function payCancel() {
		$table=$this->getTable('payment');
		$plugin=$this->_getPlugin(JRequest::getInt('id'));
		
		if(!$plugin->payCancel($table)) {
			$table->message=$plugin->getError();
			$this->setError($plugin->getError());
			if(!$table->store()) {
				$this->setError($this->_db->stderr(true));
				JFactory::getApplication()->setUserState('com_chpay.pay_id',$table->id);
				return false;
			}
			JFactory::getApplication()->setUserState('com_chpay.pay_id',$table->id);
			return false;
		}
		$table->message=JText::_('Cancelled');
		if(!$table->store()) {
			$this->setError($this->_db->stderr(true));
			JFactory::getApplication()->setUserState('com_chpay.pay_id',$table->id);
			return false;
		}
		JFactory::getApplication()->setUserState('com_chpay.pay_id',$table->id);
		return true;
	}

	function payFinish() {
		$table=$this->getTable('payment');
		$plugin=$this->_getPlugin(JRequest::getInt('id'));
		$ret=true;

		if(!$plugin->finishPay($table)) {
			$table->message=$plugin->getError();
			$this->setError($plugin->getError());
			$ret=false;
		}

		if(is_array($table->params)) {
			$reg=new JRegistry();
			$reg->loadArray($table->params);
			$table->params=$reg->toString();
		}

		if(!$table->store()) {
			$this->setError($this->_db->stderr(true));
			$ret=false;
		}

		JFactory::getApplication()->setUserState('com_chpay.pay_id',$table->id);
		return $ret;
	}

	function getReturnUrl() {
		return $this->_config->merchant_url;
	}

	private function _getPlugin($id) {
		$query="SELECT element \n";
		$query.="FROM #__plugins \n";
		$query.="WHERE id=".$id;
		$this->_db->setQuery($query);
		$plugin_name=$this->_db->loadResult();

		require_once JPATH_SITE.DS.'plugins'.DS.'chp'.DS.$plugin_name.'.php';
		$plg_name='plgCHP'.$plugin_name;
		return new $plg_name();
	}
}
?>